# Excercises for iterators
# Alexander Kosik


#########################
### Excercise 1 
#########################

class Point:
    """
    Point class with an x, y, z value

    Make this class iterable, so that if iterated over it will return 
    its x, y and z value
    e.g. 

    p = Point(1, 2, 3)
    for c in p:
        print(c, end=" ")

    >>> 1 2 3 
    """
    def __init__(self, x, y, z):
        self.x, self.y, self.z = x, y, z

    # Make Point iterable
    pass # TODO


#########################
### Excercise 2 
#########################
def infinite(value):
    """
    write a generator function which delivers the passed value infinitely.
    """
    pass # TODO


#########################
### Excercise 3 
#########################
def split(iterable, split_value):
    """
    Return a generator which will split the iterable if split_value occurs
    e.g.
    g = split_when([1, 2, 'split', 3, 4, 5, 6, 'split', 7, 8, 9], 'split')

    g(next) # delivers [1, 2]
    g(next) # delivers [3, 4, 5, 6]
    g(next) # delivers [7, 8, 9]

    For simplicity assume that iterable is always a list

    Returns:
        return a generator which delivers lists as described above.
    """
    pass # TODO


#########################
### Excercise 4 
#########################
def cards():
    """ 
    cards should yield cards from a card deck of 52 pieces 

    A card should be represented as a tuple with rank and suit
    E.g.: (2, 'spades'), (7, 'hearts'), ('Q', 'diamonds')

    Returns:
        return a generator using a generator expression which delivers all cards as described above.
    
    """
    ranks = [x for x in range(2, 11)] + list('JQKA')
    suits = 'spades diamonds clubs hearts'.split()

    # TODO
    pass
